"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var _ = require('lodash');
var styles = require('!!css-loader!less-loader!./list-headers.less');
var ListHeaders = (function () {
    function ListHeaders() {
        this.emitSort = new core_1.EventEmitter();
        this.tableMarkup = false;
    }
    ListHeaders.prototype.sort = function (header) {
        if (!header) {
            return;
        }
        if (this.sortedBy === header) {
            this.ascOrder = !this.ascOrder;
        }
        else {
            this.ascOrder = true;
        }
        this.sortedBy = header;
        this.emitSort.emit({
            order: this.ascOrder ? 'asc' : 'desc',
            sortBy: this.sortedBy
        });
    };
    ListHeaders.prototype.ngOnInit = function () {
        var sortHeader = _.find(this.headers, function (header) {
            return header.sortOnInit;
        }) || this.headers[0];
        this.ascOrder = sortHeader.sortOnInit ? sortHeader.sortOnInit === 'asc' : true;
        this.sortedBy = sortHeader.property;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], ListHeaders.prototype, "headers", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], ListHeaders.prototype, "emitSort", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], ListHeaders.prototype, "tableMarkup", void 0);
    ListHeaders = __decorate([
        core_1.Component({
            selector: 'list-headers,[ue-table-headers]',
            styles: [styles.toString()],
            template: "\n        <div *ngIf=\"!tableMarkup\" class=\"ue-list-headers\">\n            <div *ngFor=\"let header of headers\" (click)=\"sort(header.property)\" [ngStyle]=\"header.styles\" class=\"headers-each\">\n                    <span class=\"header-title\">{{(header.label || header.property) | uppercase}} </span>\n                    <span class=\"header-icon\"\n                          [ngClass]=\"ascOrder ? 'arrow-down' : 'arrow-up'\"\n                          [style.visibility]=\"(header.property && sortedBy === header.property) ? 'visible' : 'hidden' \">\n                    </span>\n            </div>\n        </div>\n        <tr *ngIf=\"tableMarkup\" class=\"ue-table-headers\">\n            <th *ngFor=\"let header of headers\" (click)=\"sort(header.property)\" [ngStyle]=\"header.styles\" class=\"headers-each\">\n                <span class=\"header-title\">{{(header.label || header.property) | uppercase}} </span>\n                <span class=\"header-icon\"\n                      [ngClass]=\"ascOrder ? 'arrow-down' : 'arrow-up'\"\n                      [style.visibility]=\"(header.property && sortedBy === header.property) ? 'visible' : 'hidden' \">\n                </span>\n            </th>\n        </tr>\n    "
        }), 
        __metadata('design:paramtypes', [])
    ], ListHeaders);
    return ListHeaders;
}());
exports.ListHeaders = ListHeaders;
var ListHeaders;
(function (ListHeaders) {
    'use strict';
})(ListHeaders = exports.ListHeaders || (exports.ListHeaders = {}));
//# sourceMappingURL=list-headers.js.map