import { OnDestroy, OnInit } from '@angular/core';
import { NotificationService } from './notification-service';
import { IAppConfig } from '../../services/context/app-config';
import { GTMService } from '../../services/context/gtm';
export declare class Notification implements OnDestroy, OnInit {
    private notificationService;
    private gtmService;
    private appConfig;
    iconCssPrefix: string;
    private serviceSubscription;
    private baseColor;
    private notification;
    private hide;
    private icon;
    private hideTime;
    private fadeTime;
    private fadeTimerHandle;
    private defaultErrorAction;
    constructor(notificationService: NotificationService, gtmService: GTMService, appConfig: IAppConfig);
    show(message: string, type?: string, gtmAction?: string): void;
    private setIconClass(type);
    close(): void;
    resetTimer(): void;
    restartTimer(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    private logUserVisibleError(message, gtmAction?);
}
