import { AfterViewInit, ElementRef, Renderer } from '@angular/core';
import { TooltipService } from '../../directives/tooltip/tooltip-service';
export declare type TooltipPlacement = 'top' | 'bottom' | 'left' | 'right';
export interface IPositions {
    top: number;
    left: number;
}
export interface ITooltipOptions {
    content?: string;
    enabled?: boolean;
    hovering?: boolean;
    maxWidth?: number;
    placement?: TooltipPlacement;
    target?: HTMLElement;
}
export declare class Tooltip implements AfterViewInit {
    private service;
    private renderer;
    options: ITooltipOptions;
    showTooltip: boolean;
    disabled: boolean;
    tooltipContainer: ElementRef;
    constructor(service: TooltipService, renderer: Renderer);
    ngAfterViewInit(): void;
    private setOptions(options);
    private positionTooltip();
    private setNewPosition(tooltip, positions);
    private calculatePositions(target, tooltip, placement);
    private edgePosition(target, tooltip, placement, styleProp);
    private centeredPosition(target, tooltip, styleProp);
}
