"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var tooltip_service_1 = require('./tooltip-service');
var TooltipDirective = (function () {
    function TooltipDirective(service) {
        this.service = service;
        this.hovering = false;
        this.maxWidth = 200;
        this.content = '';
        this.enabled = true;
        this.placement = 'top';
        this.target = undefined;
    }
    TooltipDirective.prototype.onMouseEnter = function (event) {
        this.target = event.target;
        this.hovering = true;
        this.notifyTooltipComponent();
    };
    TooltipDirective.prototype.onMouseLeave = function () {
        this.hovering = false;
        this.notifyTooltipComponent();
    };
    TooltipDirective.prototype.notifyTooltipComponent = function () {
        var options = {
            content: this.content,
            enabled: this.enabled,
            hovering: this.hovering,
            maxWidth: this.maxWidth,
            placement: this.placement,
            target: this.target
        };
        this.service.notify(options);
    };
    TooltipDirective.prototype.ngOnChanges = function () {
        this.notifyTooltipComponent();
    };
    TooltipDirective.prototype.ngOnDestroy = function () {
        this.target = undefined;
        this.hovering = false;
        this.notifyTooltipComponent();
    };
    __decorate([
        core_1.Input('ueTooltipMaxWidth'), 
        __metadata('design:type', Number)
    ], TooltipDirective.prototype, "maxWidth", void 0);
    __decorate([
        core_1.Input('ueTooltip'), 
        __metadata('design:type', String)
    ], TooltipDirective.prototype, "content", void 0);
    __decorate([
        core_1.Input('ueTooltipEnabled'), 
        __metadata('design:type', Boolean)
    ], TooltipDirective.prototype, "enabled", void 0);
    __decorate([
        core_1.Input('ueTooltipPlacement'), 
        __metadata('design:type', String)
    ], TooltipDirective.prototype, "placement", void 0);
    __decorate([
        core_1.HostListener('mouseenter', ['$event']), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [MouseEvent]), 
        __metadata('design:returntype', void 0)
    ], TooltipDirective.prototype, "onMouseEnter", null);
    __decorate([
        core_1.HostListener('mouseleave'), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], TooltipDirective.prototype, "onMouseLeave", null);
    TooltipDirective = __decorate([
        core_1.Directive({
            selector: '[ueTooltip]'
        }), 
        __metadata('design:paramtypes', [tooltip_service_1.TooltipService])
    ], TooltipDirective);
    return TooltipDirective;
}());
exports.TooltipDirective = TooltipDirective;
//# sourceMappingURL=tooltip.js.map