import { Http, RequestOptionsArgs } from '@angular/http';
import { Observable } from 'rxjs/Rx';
import { GTMService } from '../context/gtm';
import { WindowRef } from '../window-ref';
export interface ISimplifiedError {
    message: string;
    code: string;
    originalError: any;
    path: string;
}
export interface IClientBase {
    get: <T>(path: string, options?: RequestOptionsArgs) => Observable<T>;
    delete: <T>(path: string, options?: RequestOptionsArgs) => Observable<T>;
    put: <T, U>(path: string, payload: U, options?: RequestOptionsArgs) => Observable<T>;
    post: <T, U>(path: string, payload: U, options?: RequestOptionsArgs) => Observable<T>;
}
export declare class Client implements IClientBase {
    private http;
    private gtmService;
    private win;
    constructor(http: Http, gtmService: GTMService, win: WindowRef);
    private mapToJson;
    private catchOrRedirect;
    private mapAndCatch;
    get: <T>(path: string, options?: RequestOptionsArgs) => Observable<T>;
    delete: <T>(path: string, options?: RequestOptionsArgs) => Observable<T>;
    put: <T, U>(path: string, payload: U, options?: RequestOptionsArgs) => Observable<T>;
    post: <T, U>(path: string, payload: U, options?: RequestOptionsArgs) => Observable<T>;
}
