import { Observable } from 'rxjs/Rx';
import { ISimplifiedError } from './client';
export declare type ClientEvent = 'error' | 'start' | 'complete' | 'next';
export declare type ClientMethod = 'get' | 'put' | 'post' | 'delete';
export interface IClientEvent {
    stackCount: number;
    event: ClientEvent;
    method: ClientMethod;
    error?: any;
    errorInfo?: ISimplifiedError;
    path?: string;
}
export declare class ClientObserver {
    private _emitter;
    private _stackCount;
    clientEvents: Observable<IClientEvent>;
    private countUp;
    private countDown;
    emitChange: (event: ClientEvent, method: ClientMethod, path?: string, error?: any) => void;
    observeOn: <T>(method: ClientMethod, obs: Observable<T>, path?: string) => Observable<T>;
    reset: () => void;
}
