"use strict";
var ObservableClientBase = (function () {
    function ObservableClientBase(client, spy) {
        var _this = this;
        this.client = client;
        this.spy = spy;
        this.spyCall = function (method, obs, path) {
            return _this.spy ? _this.spy.observeOn(method, obs, path) : obs;
        };
        this.put = function (url, entity) { return _this.spyCall('put', _this.client.put(url, entity), url); };
        this.get = function (url) {
            return _this.spyCall('get', _this.client.get(url), url);
        };
        this.delete = function (url) { return _this.spyCall('delete', _this.client.delete(url), url); };
        this.post = function (url, entity) { return _this.spyCall('post', _this.client.post(url, entity), url); };
        this.spy = spy;
    }
    return ObservableClientBase;
}());
exports.ObservableClientBase = ObservableClientBase;
//# sourceMappingURL=observable-client-base.js.map