"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var rbac_abacus_1 = require('rbac-abacus');
var observable_client_base_1 = require('./observable-client-base');
var ObservableClient = (function (_super) {
    __extends(ObservableClient, _super);
    function ObservableClient(client, router, spy) {
        var _this = this;
        _super.call(this, client, spy);
        this.router = router;
        this.userInfo = function () { return _this.get(_this.router.userInfo()); };
        this.updateEntity = function (identifier, entity) {
            return _this.put(_this.router.entity(identifier), entity);
        };
        this.deleteEntity = function (identifier) {
            return _this.delete(_this.router.entity(identifier));
        };
        this.createEntity = function (entity) {
            return _this.post(_this.router.new(), entity);
        };
        this.getEntity = function (identifier) {
            return _this.get(_this.router.entity(identifier));
        };
        this.getListObject = function () {
            return _this.get(_this.router.list());
        };
        this.permissions = function () {
            return _this.userInfo()
                .flatMap(function (info) { return _this.get(_this.router.permissions(info.email)); })
                .map(function (response) { return ({
                resourcePermission: response.resourcePermission
                    .filter(function (p) { return p.organization === _this.router.orgName; })
            }); })
                .map(function (response) { return new rbac_abacus_1.RolePermissions(response); });
        };
    }
    return ObservableClient;
}(observable_client_base_1.ObservableClientBase));
exports.ObservableClient = ObservableClient;
//# sourceMappingURL=observable-client.js.map