"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var common_1 = require('@angular/common');
require('rxjs/Rx');
var app_config_1 = require('./app-config');
var context_helper_1 = require('./context-helper');
var gtm_1 = require('./gtm');
var window_ref_1 = require('../window-ref');
var Context = (function () {
    function Context(_orgName) {
        this._orgName = _orgName;
    }
    Object.defineProperty(Context.prototype, "orgName", {
        get: function () { return this._orgName; },
        enumerable: true,
        configurable: true
    });
    return Context;
}());
exports.Context = Context;
var EmptyContext = (function () {
    function EmptyContext() {
    }
    Object.defineProperty(EmptyContext.prototype, "orgName", {
        get: function () { return undefined; },
        enumerable: true,
        configurable: true
    });
    return EmptyContext;
}());
var ContextService = (function () {
    function ContextService(location, window, gtmService, appConfig) {
        this.location = location;
        this.window = window;
        this.gtmService = gtmService;
        this.appConfig = appConfig;
        this.helper = new context_helper_1.ContextHelper(window);
    }
    ContextService.prototype.getContext = function () {
        var path = this.location.path();
        var orgFromUrl = this.helper.orgNameFromPath(path);
        var userName = this.helper.getUser();
        var userId = this.helper.getUuid();
        if (orgFromUrl) {
            this.helper.orgNameToLocal(orgFromUrl);
            this.gtmService.updateGtmContext(orgFromUrl, userId, userName);
            return new Context(orgFromUrl);
        }
        var orgFromLocalStorage = this.helper.orgNameFromLocal();
        if (orgFromLocalStorage) {
            var newPath = "/organizations/" + orgFromLocalStorage + "/" + this.appConfig.appBasePath;
            this.gtmService.updateGtmContext(orgFromLocalStorage, userId, userName);
            this.location.go(newPath);
            return new Context(orgFromLocalStorage);
        }
        this.window.location('/no-org');
        return new EmptyContext();
    };
    Object.defineProperty(ContextService.prototype, "orgName", {
        get: function () {
            if (this._orgName) {
                return this._orgName;
            }
            this._orgName = this.getContext().orgName;
            return this._orgName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ContextService.prototype, "userEmail", {
        get: function () {
            return this.helper.getUser();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ContextService.prototype, "uuid", {
        get: function () {
            return this.helper.getUuid();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ContextService.prototype, "sessionContext", {
        get: function () {
            return this.helper.getSessionContext();
        },
        enumerable: true,
        configurable: true
    });
    ContextService = __decorate([
        core_1.Injectable(),
        __param(3, core_1.Inject(app_config_1.APP_CONFIG)), 
        __metadata('design:paramtypes', [common_1.Location, window_ref_1.WindowRef, gtm_1.GTMService, Object])
    ], ContextService);
    return ContextService;
}());
exports.ContextService = ContextService;
//# sourceMappingURL=context.js.map