import { WindowRef } from '../window-ref';
import { IAppConfig } from './app-config';
export interface IGAPageView {
    event: string;
    'content-name': string;
}
export interface IGAEventProps {
    action: string | number;
    event?: string;
    category?: string;
    label?: string | number;
    value?: any;
    noninteraction?: boolean;
}
export interface IGAEvent {
    event?: string;
    target?: string;
    action?: string | number;
    'target-properties'?: string | number;
    value?: string | number;
    'interaction-type'?: boolean;
}
export interface IGTMContext {
    'user.uuid'?: string;
    'user.email'?: string;
    'user.internal'?: string;
    'organization.name'?: string;
    'organization.type'?: string;
    'webapp.name': string;
    'webapp.version'?: string;
    'event'?: string;
}
export declare class GTMService {
    private window;
    private appConfig;
    constructor(window: WindowRef, appConfig: IAppConfig);
    registerPageTrack(path: string): void;
    registerEventTrack(properties: IGAEventProps): void;
    registerUserVisibleError(errorMessage: string, action?: string): void;
    registerSPAEvent(properties: IGAEventProps): void;
    registerClientCall(responseCode: number, path: string, responseTime: number): void;
    updateGtmContext(orgName?: string, uuid?: string, email?: string): void;
}
