"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var window_ref_1 = require('../window-ref');
var app_config_1 = require('./app-config');
var GTMService = (function () {
    function GTMService(window, appConfig) {
        this.window = window;
        this.appConfig = appConfig;
    }
    GTMService.prototype.registerPageTrack = function (path) {
        if (!path) {
            return;
        }
        this.window.registerPageTrack(path);
    };
    GTMService.prototype.registerEventTrack = function (properties) {
        this.window.registerEventTrack(properties);
    };
    GTMService.prototype.registerUserVisibleError = function (errorMessage, action) {
        var props = {
            action: action,
            category: 'Edge_userVisibleError',
            event: 'interaction',
            label: errorMessage,
            noninteraction: true
        };
        this.window.registerEventTrack(props);
    };
    GTMService.prototype.registerSPAEvent = function (properties) {
        var newProps = Object.assign({}, properties, { category: this.appConfig.gtmAppName });
        this.window.registerEventTrack(newProps);
    };
    GTMService.prototype.registerClientCall = function (responseCode, path, responseTime) {
        var props = {
            action: responseCode,
            category: 'Edge_APICall',
            event: 'timing',
            label: path,
            noninteraction: true,
            value: responseTime
        };
        this.window.registerEventTrack(props);
    };
    GTMService.prototype.updateGtmContext = function (orgName, uuid, email) {
        var context = {
            'organization.name': orgName,
            'webapp.name': this.appConfig.gtmAppName,
            'event': 'Push Context'
        };
        if (/^[^@]+@apigee.com/.test(email || '')) {
            context['user.internal'] = 'internal';
        }
        if (uuid) {
            context['user.uuid'] = uuid;
        }
        if (email) {
            context['user.email'] = email;
        }
        this.window.gtmContext(context);
    };
    GTMService = __decorate([
        core_1.Injectable(),
        __param(1, core_1.Inject(app_config_1.APP_CONFIG)), 
        __metadata('design:paramtypes', [window_ref_1.WindowRef, Object])
    ], GTMService);
    return GTMService;
}());
exports.GTMService = GTMService;
//# sourceMappingURL=gtm.js.map